<template>
  <div class="date-time-panel vertical-menu-panel flex-grow-0 flex-column" v-bind:class="panelDisplayClass()">

    <!-- date-time-panel-header -->
    <div class="date-time-panel-header d-flex flex-row bg-primary pl-3 py-3">
      <h1 class="flex-grow-1 text-light mb-0">
        <span class="mr-2"><font-awesome-icon icon="calendar-alt"/></span>
        Data e hora
      </h1>
      <button class="btn flex-grow-0 text-light mr-2 close-btn" @click="closePanel">
        <font-awesome-icon icon="times"/>
      </button>
    </div>

    <!-- listings -->
    <div class="d-flex flex-grow-1 flex-column px-3">
      <reference-time-picker/>
      <div class="d-flex flex-column flex-grow-0 mt-4">
        <h2>Hora da previsão</h2>
        <div class="btn-group" role="group">
          <template v-if="referenceHour === 0">
            <button type="button" class="btn btn-primary" @click="setReferenceHour(0)">0 Horas</button>
            <button type="button" class="btn" @click="setReferenceHour(12)">12 Horas</button>
          </template>
          <template v-else>
            <button type="button" class="btn btn" @click="setReferenceHour(0)">0 Horas</button>
            <button type="button" class="btn btn-primary" @click="setReferenceHour(12)">12 Horas</button>
          </template>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import moment from 'moment'
import { SET_WORKSPACE_CURRENT_PANEL, SET_WORKSPACE_REFERENCE_TIME } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import ReferenceTimePicker from '@/workspace/components/time/ReferenceTimePicker'

export default {
  name: 'datetimepanel',

  mixins: [
    WorkspaceGetter
  ],

  props: {
    name: {
      type: String,
      required: true
    }
  },

  computed: {
    referenceTime: {
      get() {
        return moment.unix(this.$store.getters.workspaceReferenceTime(this.workspaceId)).toDate()
      }
    },

    referenceHour: {
      get () {
        const time = moment.unix(this.$store.getters.workspaceReferenceTime(this.workspaceId))
        return time.hour()
      }
    },

    isCurrentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspaceId) === this.name
      }
    },
  },

  methods: {
    setReferenceHour (value) {
      const newReferenceTime = moment(this.referenceTime)
      if(this.referenceHour !== value) {
        this.$store.commit(SET_WORKSPACE_REFERENCE_TIME, {
          workspaceId: this.workspaceId,
          referenceTime: newReferenceTime.clone().hour(value).unix()
        })
      }
    },

    panelDisplayClass() {
      return {
        'd-flex': this.isCurrentPanel,
        'd-none': !this.isCurrentPanel,
      }
    },

    closePanel() {
      this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
        workspaceId: this.workspaceId,
        pane: null
      })
    },
  },

  components: {
    ReferenceTimePicker,
  },
}
</script>
